﻿<?php

class SendSMS {
	const SIZE7BIT = 160;
	const SIZE8BIT = 70;
	private $a_msg = array();
	private $a_spans = array();
	private $a_vspans = array();
	private $a_numbers = array();

	private $wait_context=array();

	private $_verbose = 0;
	private $_msg = "";
	private $_spans = "";
	private $_numbers = "";

	public function __construct() {
		//ignore_user_abort(false);
		set_time_limit(0);
		mb_internal_encoding('UTF-8');
    }

	public function trace($context) {
		echo "$context";
		echo "<br>";
		ob_flush();
		flush();
	}

	public function is_brower_colose() {

		if(connection_status() != 0)
			return true;

		echo ' ';
		flush();
		ob_flush();
		
		return false; 
	}

	public function isAscii($MSG) {
		return (strlen($MSG) == mb_strlen($MSG));
	}

	public function init() {
		if(!$this->getValidSpans())
			return false;

		if(!$this->dealMsg($this->_msg))
			return false;

		if(!$this->dealSpans($this->_spans))
			return false;

		if(!$this->dealNumbers($this->_numbers))
			return false;

		return true;
	}

	public function dealMsg($MSG) {
		if($this->isAscii($MSG)){
			$size = self::SIZE7BIT;
		} else {
			$size = self::SIZE8BIT;
		}

		//Divide string
		$len = mb_strlen($MSG);
		$tmp = (int)($len/$size);
		for($i=0; $i<$tmp; $i++) {
			$msg = mb_substr($MSG, $i*$size, $size);
			$this->a_msg[] = $msg;
		}

		//Remain string
		$tmp = (int)($len%$size);
		if($tmp !=0 ) {
			$msg = mb_substr($MSG, $i*$size, $tmp);
			$this->a_msg[] = $msg;
		}

		if(empty($this->a_msg)) {
			$this->trace("No has SMS to send!"); 
			return false;
		}

		return true;
	}
	

	public function dealSpans($SPANS) {

		if($SPANS == "auto") {
			$this->a_spans=$this->a_vspans;
			return true;
		}


		$len = strlen($SPANS);
		$start = 0;
		for($i=0; $i<$len; $i++) {
			if($SPANS[$i] == ' ' || $SPANS[$i] == ',' || $SPANS[$i] == ';') {
				$span = trim(substr($SPANS,$start,$i-$start));
				if($span != '') {
					if ($this->isValidSpan($span) && !$this->hasSame($this->a_spans, $span)) {
						$this->a_spans[] = $span;
					}
				}
				$start = $i+1;
			}
		}
		$span = trim(substr($SPANS,$start,$len-$start));
		if($span != '') {
			if ($this->isValidSpan($span) && !$this->hasSame($this->a_spans, $span)) {
				$this->a_spans[] = $span;
			}		
		}

		if(empty($this->a_spans)) {
			$this->trace("No has spans to send!");
			return false;
		}

		return true;
	}

	public function dealNumbers($NUMBERS) {
		$len = strlen($NUMBERS);
		$start = 0;

		for($i=0; $i<$len; $i++) {
			if($NUMBERS[$i] == ' ' || $NUMBERS[$i] == ',' || $NUMBERS[$i] == ';'|| $NUMBERS[$i] == '.' || $NUMBERS[$i] == '\r' || $NUMBERS[$i] == '\n') {
				$number = trim(substr($NUMBERS,$start,$i-$start));
				if($number != '') {
					if ($this->isValidNumber($number) && !$this->hasSame($this->a_numbers, $number)) {
						$this->a_numbers[] = $number;
					}
				}
				$start = $i+1;
			}
		}
		$number = trim(substr($NUMBERS,$start,$len-$start));
		if($number != '') {
			if ($this->isValidNumber($number) && !$this->hasSame($this->a_numbers, $number)) {
				$this->a_numbers[] = $number;
			}		
		}

		if(empty($this->a_numbers)){
			return false;
		}

		return true;
	}

	public function getValidSpans() {
		exec("asterisk -rx \"gsm show spans\" || echo 'error'",$output);
		if(end($output) == 'error') {
			$this->trace( "Call asterisk failed");
			return false;
		}
		 
		foreach($output as $each) {
			if(strstr($each, 'Up, Active')) {
				sscanf($each, "GSM span %d: ",$span);
				if(is_integer($span))
					$this->a_vspans[] = $span;
			}
		}

		if(empty($this->a_vspans)) {
			$this->trace("No has valid spans");
			return false;
		}

		return true;
	}

	public function isValidSpan($span) {
		foreach($this->a_vspans as $each) {
			if($each == $span)
				return true;
		}

		return false;
	}


	public function isValidNumber($number) {
		return preg_match('/^[+0-9][0-9]+$/',$number);
	}


	public function hasSame($array, $member) {
		foreach($array as $each) {
			if($each === $member) {
				return true;
			}
		}

		return false;
	}

	public function makeid() {
		date_default_timezone_set('UTC');
		static $tmp=0;
		$id=date("YmdHim");
		$id="${id}${tmp}";
		$tmp++;
		while(file_exists("/tmp/sms/S$id") || file_exists("/tmp/sms/F$id")) {
			$id++;
		}
		return $id;
	}

	public function send_sms($span, $number, $msg, $attempt) {
		if($this->_verbose > 2)
			$this->trace("Start sending \"$msg\" to \"$number\" from span \"$span\"");

		$id = $this->makeid();

		exec("asterisk -rx \"gsm send sms \\\"$span\\\" \\\"$number\\\" \\\"$msg\\\" \\\"$id\\\"\" > /dev/null 2>&1 || echo $?",$output);
		if($output) {
			if($this->_verbose > 1)
				echo "Sending \"$msg\" to \"$number\" from span \"$span\" was failed!!!\n";

			return;
		}

//		$this->trace("asterisk -rx \"gsm send sms \\\"$span\\\" \\\"$number\\\" \\\"$msg\\\" \\\"$id\\\"\"");

		$context = array(
			'id' => $id,
			'msg' => $msg,
			'number' => $number,
			'span' => $span,
			'attempt' => $attempt
		);

		$this->wait_context[] = $context;
	}


	public function wait_send() {

		for(;;) {

			if(empty($this->wait_context))
				return;

			foreach($this->wait_context as $key => $context) {
				if( !isset($context['id']) || !isset($context['msg']) || !isset($context['number']) || !isset($context['span']) || !isset($context['attempt']) ) {
					unset($context);
					continue;
				}

				if(file_exists("/tmp/sms/S${context['id']}")) { //Send Successful
					unlink("/tmp/sms/S${context['id']}");

					if($this->_verbose > 1)
						$this->trace("Sending \"${context['msg']}\" to \"${context['number']}\" from span \"${context['span']}\" was successful.");

					unset($this->wait_context[$key]);
				} else if (file_exists("/tmp/sms/F${context['id']}")) { //Send Failed
					unlink("/tmp/sms/F${context['id']}");

					if ($context['attempt'] == -1) {
						if($this->_verbose > 2)
							$this->trace("Trying to re-send \"${context['msg']}\" to \"${context['number']}\" from span \"${context['span']}\" (always)");
						
						$this->send_sms($context['span'], $context['number'], $context['msg'], -1);

						unset($this->wait_context[$key]);
					} else if ($context['attempt'] > 1) {
						$attempt=$context['attempt']-1;
						if($this->_verbose > 2)
							$this->trace("Trying to re-send \"${context['msg']}\" to \"${context['number']}\" from span \"${context['span']}\" ($attempt)");

						$this->send_sms($context['span'], $context['number'], $context['msg'], $attempt);
						unset($this->wait_context[$key]);
					} else {
						if($this->_verbose > 1)
							$this->trace("Sending \"${context['msg']}\" to \"${context['number']}\" from span \"${context['span']}\" was failed!!!");

						unset($this->wait_context[$key]);
					}
				}

				if($this->is_brower_colose()) {
					exit(0);
				}
			}
		}
	}


	public function send($MSG, $SPANS, $NUMBERS, $ATTEMPT, $VERBOSE, $REPEAT) {
		$this->_verbose = $VERBOSE;
		$this->_spans = $SPANS;
		$this->_numbers = $NUMBERS;

		$msg = $MSG;

		//replace '\' (must first then replace '"')
		$msg = str_replace("\\","\\\\\\\\",$msg);

		//replace '"'
		$msg = str_replace("\"","\\\\\\\"",$msg);

		$this->_msg = $msg;

		if(!$this->init())
			return;

		$j = 0;
		foreach($this->a_numbers as $number) {
			if( $j >= count($this->a_spans) ) {
				$j = 0;
			}

			foreach($this->a_msg as $msg) {
				for($i=1; $i<=$REPEAT; $i++) {
					$this->send_sms($this->a_spans[$j],$number, $msg, $ATTEMPT);
				}
			}

			$j++;
		}

		$this->wait_send();
		$this->trace("Sended finish");
		//print_r($this->wait_context);
	}
}

?>
